"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class imu_lcm(object):
    __slots__ = ["yaw", "mag_x", "mag_y", "accel_x", "accel_y", "gyro_x", "gyro_y"]

    def __init__(self):
        self.yaw = 0.0
        self.mag_x = 0.0
        self.mag_y = 0.0
        self.accel_x = 0.0
        self.accel_y = 0.0
        self.gyro_x = 0.0
        self.gyro_y = 0.0

    def encode(self):
        buf = BytesIO()
        buf.write(imu_lcm._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">ddddddd", self.yaw, self.mag_x, self.mag_y, self.accel_x, self.accel_y, self.gyro_x, self.gyro_y))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != imu_lcm._get_packed_fingerprint():
            raise ValueError("Decode error")
        return imu_lcm._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = imu_lcm()
        self.yaw, self.mag_x, self.mag_y, self.accel_x, self.accel_y, self.gyro_x, self.gyro_y = struct.unpack(">ddddddd", buf.read(56))
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if imu_lcm in parents: return 0
        tmphash = (0xa6abf09b33358f48) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if imu_lcm._packed_fingerprint is None:
            imu_lcm._packed_fingerprint = struct.pack(">Q", imu_lcm._get_hash_recursive([]))
        return imu_lcm._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

